Package org.apache.lucene.analysis.miscellaneous

## Class TypeAsSynonymFilterFactory

- java.lang.Object
- - org.apache.lucene.analysis.AbstractAnalysisFactory
  - - org.apache.lucene.analysis.TokenFilterFactory
    - - org.apache.lucene.analysis.miscellaneous.TypeAsSynonymFilterFactory

-     public class TypeAsSynonymFilterFactory
      extends TokenFilterFactory

  Factory for `TypeAsSynonymFilter`.

  In Solr this might be used as such

       <fieldType name="text_type_as_synonym" class="solr.TextField" positionIncrementGap="100">
         <analyzer>
           <tokenizer class="solr.UAX29URLEmailTokenizerFactory"/>
           <filter class="solr.TypeAsSynonymFilterFactory" prefix="_type_" synFlagsMask="5" ignore="foo,bar"/>
         </analyzer>
       </fieldType>

  If the optional `prefix` parameter is used, the specified value will be prepended to the type, e.g. with prefix="_type_", for a token "example.com" with type "<URL>", the emitted synonym will have text "_type_<URL>". If the optional synFlagsMask is used then the flags on the synonym will be set to `synFlagsMask & tokenFlags`. The example above transfers only the lowest and third lowest bits. If no mask is set then all flags are transferred. The ignore parameter can be used to avoid creating synonyms for some types.

  Since:
    7.3.0
  SPI Name (case-insensitive: if the name is 'htmlStrip', 'htmlstrip' can be used when looking up the service).
    "typeAsSynonym"

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static String` | `NAME` | SPI name

    - ### Fields inherited from class org.apache.lucene.analysis.AbstractAnalysisFactory

      `LUCENE_MATCH_VERSION_PARAM, luceneMatchVersion`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `TypeAsSynonymFilterFactory()` | Default ctor for compatibility with SPI
    `TypeAsSynonymFilterFactory​(Map<String,​String> args)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `TokenStream` | `create​(TokenStream input)` |

    - ### Methods inherited from class org.apache.lucene.analysis.TokenFilterFactory

      `availableTokenFilters, findSPIName, forName, lookupClass, normalize, reloadTokenFilters`

    - ### Methods inherited from class org.apache.lucene.analysis.AbstractAnalysisFactory

      `defaultCtorException, get, get, get, get, get, getBoolean, getChar, getClassArg, getFloat, getInt, getLines, getLuceneMatchVersion, getOriginalArgs, getPattern, getSet, getSnowballWordSet, getWordSet, isExplicitLuceneMatchVersion, require, require, require, requireBoolean, requireChar, requireFloat, requireInt, setExplicitLuceneMatchVersion, splitAt, splitFileNames`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### NAME

          public static final String NAME

      SPI name
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### TypeAsSynonymFilterFactory

          public TypeAsSynonymFilterFactory​(Map<String,​String> args)

    - #### TypeAsSynonymFilterFactory

          public TypeAsSynonymFilterFactory()

      Default ctor for compatibility with SPI

  - ### Method Detail

    - #### create

          public TokenStream create​(TokenStream input)

      Specified by:
        `create` in class `TokenFilterFactory`